/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : winding_machine
Version : 1
Date    : 30.03.2019
Author  : Khodnevych Vitalii
Company : 
Comments: 


Chip type               : ATmega8A
Program type            : Application
AVR Core Clock frequency: 1.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega8.h>
      #include <delay.h>

// Declare your global variables here
        int Enc_M=0; 

char encoderM;
//FSM on encoder 
int Encoder_M(int inc)
{    // int inc=value;//increment
encoderM=(encoderM<< 2)+2*PIND.3+PIND.2;
  switch (encoderM&0x0F) {  
             case 7: 
             inc=inc+1;
             break;
             case 14: 
             inc=inc+1;
             break;     
             case 8: 
             inc=inc+1;
             break;
             case 1: 
             inc=inc+1;
             break; 
             case 13: 
             inc=inc-1;
             break;
             case 4: 
             inc=inc-1;
             break;     
             case 2: 
             inc=inc-1;
             break;
             case 11: 
             inc=inc-1;
             break;
             default:
             break;
      }      
      return inc;
}
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
// Place your code here
          Enc_M=Encoder_M(Enc_M);   

}

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{
// Place your code here
        Enc_M=Encoder_M(Enc_M);   

}


 
char encoder;
//FSM on encoder 
int Encoder_f(void)
{     int inc=0;//increment
encoder=(encoder<< 2)+2*PIND.1+PIND.0;
  switch (encoder&0x0F) {  
             case 7: 
             inc=inc+1;
             break;
             case 14: 
             inc=inc+1;
             break;     
             case 8: 
             inc=inc+1;
             break;
             case 1: 
             inc=inc+1;
             break; 
             case 13: 
             inc=inc-1;
             break;
             case 4: 
             inc=inc-1;
             break;     
             case 2: 
             inc=inc-1;
             break;
             case 11: 
             inc=inc-1;
             break;
             default:
             break;
      }      
      return inc;
}


 




void number(int num)
{    
switch (num) {
        case 0:
              PORTC=0b11000001;  
              PORTB.2=0;
              break;
        case 1:
              PORTC=0b111111011;
              PORTB.2=0;                                                    
              break;  
        case 2: 
              PORTC=0b11001100;
              PORTB.2=0;        
              break;
        case 3: 
              PORTC=0b11101000; 
              PORTB.2=0;        
              break;                
        case 4: 
              PORTC=0b11110010; 
              PORTB.2=0;        
              break;     
        case 5: 
              PORTC=0b11100000; 
              PORTB.2=1;        
              break; 
        case 6: 
              PORTC=0b11000000;   
              PORTB.2=1;        
              break;  
        case 7: 
              PORTC=0b11110001;  
              PORTB.2=0;    
              break;       
        case 8: 
              PORTC=0b11000000; 
              PORTB.2=0;        
              break;         
        case 9: 
              PORTC=0b11100000;  
              PORTB.2=0;        
              break;  
        case 10:  //F
              PORTC=0b11010100; 
              PORTB.2=1;          
              break;
        case 11:   //L
              PORTC=0b11000111; 
              PORTB.2=1;          
              break;    
        case 12:   //L
              PORTC=0xff; 
              PORTB.2=1;          
              break;  
                                
            }       
     //if (dot) {PORTD |= 1 << 7;}
}

void show_num(int inum,int idel)
{
int val=12;
//inum -- number to show on 4 digit indicator
//idel -- delay between digits switching for dynamic indication
if (val>=0) {val=inum%10;}else{val=12;}
number(val); //ones
PORTD.4=0; PORTD.5=1;  PORTD.6=1;   PORTD.7=1;
delay_ms(idel);
if (inum>9){val=(inum%100-inum%10)/10;}else{val=12;}
number(val);  //tens
PORTD.4=1; PORTD.5=0;  PORTD.6=1;   PORTD.7=1;
delay_ms(idel);

if (inum>99){val=(inum%1000-inum%100)/100;}else{val=12;}
number(val);  //hundrets
PORTD.4=1; PORTD.5=1;  PORTD.6=0;   PORTD.7=1;
delay_ms(idel);

if (inum>999){val=(inum%10000-inum%1000)/1000;}else{val=12;}
number(val);  //1000s
PORTD.4=1; PORTD.5=1;  PORTD.6=1;   PORTD.7=0;
delay_ms(idel);
}


//Button (encoder) polling on timer interrupt 
  int dirL=0; 
  int dirR=0;
  int Enc_val=0;  
  int push=0;  
  interrupt [TIM0_OVF] void timer0_ovf_isr(void)
    {
     int inc=Encoder_f();   
     if (inc>0)     {dirR++;}  
     if (inc<0)     {dirL++;} 
     if (dirR==4) {Enc_val+=1; dirR=0; dirL=0;}   //one click of encoder is increase in 4
     if (dirL==4) {Enc_val-=1; dirR=0; dirL=0;} 


     //check encoder button  
     if(PINB.0==0) {delay_ms(200);     push+=1; if (push==2) {push=0;}}  //Source of problems??? 200ms
     //Heater part 
     /*if(PINC.5==1)  {
        if (adc<temp) {PORTC.0=1;}
        else          {PORTC.0=0;}  
        }   
     else {        
     
         show_sym(0,10,10,1);     //Show "OFF" 
         PORTB.1=0; //Relay off  
         PORTC.0=0; //Optocoupler off   
         //check if flow!=0. Here a priory flow!=0
         //Safety check on heater temperature
         if (adc<40){ OCR1B=0;}  //wait while heater will be cold 
         }  */
     }


int MSpeed=0;
int Count=0;
int Turns=0;
void main(void)
{

DDRB=0b00000110;
PORTB=0;

DDRC=0b00111111;
PORTC=0;

DDRD=0b11110000;
PORTD=0;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125 kHz
TCCR0=(0<<CS02) | (1<<CS01) | (0<<CS00);
TCNT0=0x00;


     

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 1000.000 kHz
// Mode: Fast PWM top=0x00FF
// OC1A output: Non-Inverted PWM
// OC1B output: Disconnected
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 0.256 ms
// Output Pulse(s):
// OC1A Period: 0.256 ms Width: 0 us
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=(1<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (1<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (0<<CS11) | (1<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;


  // Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (1<<TOIE0);


         
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: On
// INT1 Mode: Any change
GICR|=(1<<INT1) | (1<<INT0);
MCUCR=(0<<ISC11) | (1<<ISC10) | (0<<ISC01) | (1<<ISC00);
GIFR=(1<<INTF1) | (1<<INTF0);


// Global enable interrupts
#asm("sei")
while (1)
      {  
        Turns=Enc_M/290;
if (Turns>=Count)
{
//enable PWM
OCR1AL=0;//stop motor      
}

     
             switch (push) {
        case 0:  //Default 
            show_num(Turns, 1); //show counter   
            MSpeed+=Enc_val;
            if (MSpeed>255) {MSpeed=255;}
            if (MSpeed<0) {MSpeed=0;}
            Enc_val=0;
            OCR1AL=MSpeed &0xff; //set motor speed
            break;  
        case 1:  //set temperature  
            show_num(Count, 1);
            Count+=Enc_val;
            if (Count<0) {Count=0;}
            Enc_val=0; 
            OCR1AL=0;//stop motor      
            Enc_M=0; //zero turns counter
            break; 
        }; //end switch 



 
      }
}




